/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Bomb class which handles dealing with**
**killing enemies with a radial effect.			**
*************************************************/

#ifndef BOMB_H
#define BOMB_H

#include "baseTypes.h"
#include "Vector2.h"
#include "Object.h"

/*************************************************
**Summary: Bomb class which extends object class**
**used to expand in radius to do AOE attack.	**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class BombC : public ObjectC
{
public:
	BombC();
	~BombC();
	//Function prototypes.
	void init(Vector3C initPosition, Vector3C initVelocity, double64_t initTimeToLive, double64_t initTimeBetweenUpdates);
	bool update(double64_t milliseconds);
	void draw();
	void shutdown();
	void render();
private:
	//Attributes of bomb.
	Vector3C position;
	Vector3C velocity;
	float_t radius;
	double64_t totalTime;
	double64_t timeBetweenUpdates;
	double64_t currentTime;
	double64_t timeToLive;
	bool active;
	bool emit;
};
#endif