/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Bullet class which is used to detect **
**if the player is hitting an enemy with		**
**projectiles.									**
*************************************************/

#ifndef BULLET_H
#define BULLET_H

#include "Vector2.h"
#include "Object.h"

/*************************************************
**Summary: Bullet class which handles its   	**
**movement and rendering.						**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class BulletC : public ObjectC
{
public:
	 BulletC();
    ~BulletC();
	//Function prototypes.
	void update(unsigned long milliseconds);
	void DoCollisions();
	void render();
	//Radius
    void setRadius(float radius) {mCollInfo.param1 = radius;mRadius = radius;};
	float_t getRadius();
	//Position
	void setPosition(Vector3C newPosition);
	void setPosition(float_t newX, float_t newY);
	//Velocity
	void setVelocity(Vector3C newVelocity);
	void reduceVelocity(float_t factor);
	void moveUp();
private:
	//Attributes of bullet object.
	Vector3C position;
	Vector3C velocity;
	float_t mRadius;
	SpriteC mySprite;
	void CollideField();
};
#endif