/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Camera manager to control where		**
**camera is pointing.							**
*************************************************/

#define Camera_MANAGER_CPP
#include <windows.h>											// Header File For Windows
#include <stdio.h>												// Header File For Standard Input / Output
#include <stdarg.h>												// Header File For Variable Argument Routines
#include <math.h>												// Header File For Math Operations
#include "gl\gl.h"												// Header File For The OpenGL32 Library
#include "gl\glu.h"												// Header File For The GLu32 Library
#include "gl\glut.h"
#include "baseTypes.h"
#include "openglframework.h"	
#include "CameraManager.h"
#include "gamePlayVariables.h"

CameraManagerC* CameraManagerC::sInstance=NULL;

void CameraManagerC::init()
{
	//Camera Position
	cameraPosition.x = 0;
	cameraPosition.y = 0;
	cameraPosition.y = 500;
	//Screen/Camera View Size
	cameraViewSize.x = CAMERA_VIEW_SIZE_X;
	cameraViewSize.y = CAMERA_VIEW_SIZE_Y;
}
CameraManagerC *CameraManagerC::CreateInstance()
{
	if(sInstance!=NULL)return sInstance;
	else
	sInstance = new CameraManagerC();
	return sInstance;
}
Vector3C CameraManagerC::getCameraPosition()
{
	return(cameraPosition);
}
void CameraManagerC::setCameraPosition(Vector3C newCameraPosition)
{
	cameraPosition.x = newCameraPosition.x;
	cameraPosition.y = newCameraPosition.y;
	cameraPosition.z = newCameraPosition.z;

	Vector3C screenPosition = CameraManagerC::GetInstance()->getCameraPosition();
	Vector2C screenSize = CameraManagerC::GetInstance()->getCameraViewSize();

	//Finding the edges of the viewport.
	leftEdge = screenPosition.x - (screenSize.x/HALF);
	rightEdge = screenPosition.x + (screenSize.x/HALF);
	upperEdge = screenPosition.y - (screenSize.y/HALF);
	lowerEdge = screenPosition.y + (screenSize.y/HALF);

}
void CameraManagerC::shutdown()
{
}

Vector2C CameraManagerC::getCameraViewSize()
{
	return(cameraViewSize);
}

bool CameraManagerC::checkIfInViewport(Vector2C checkPosition)
{
	if((checkPosition.x > leftEdge) && (checkPosition.x < rightEdge))
	{
		if((checkPosition.y > upperEdge) && (checkPosition.y < lowerEdge))
		{
			return(true);
		}
	}
	return(false);
}

bool CameraManagerC::checkIfInViewport(Vector3C checkPosition)
{
	if((checkPosition.x > leftEdge) && (checkPosition.x < rightEdge))
	{
		if((checkPosition.y > upperEdge) && (checkPosition.y < lowerEdge))
		{
			return(true);
		}
	}
	return(false);
}