/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Camera manager to control where		**
**camera is pointing.							**
*************************************************/

#include "Vector2.h"
#include "Vector3.h"
#include "baseTypes.h"

/*************************************************
**Summary: Camera class to control where camera **
**is pointing.									**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class CameraManagerC
{
public:
	static CameraManagerC	*CreateInstance();
	static CameraManagerC	*GetInstance() {return sInstance;};
	~CameraManagerC(){};
	//Function prototypes.
	void init();
	Vector3C getCameraPosition();
	void setCameraPosition(Vector3C newCameraPosition);
	Vector2C getCameraViewSize();
	bool checkIfInViewport(Vector2C checkPosition);
	bool checkIfInViewport(Vector3C checkPosition);
	void shutdown();
private:
	Vector3C cameraPosition;
	Vector2C cameraViewSize;
	//Edges of the viewport.
	float_t leftEdge;
	float_t rightEdge;
	float_t upperEdge;
	float_t lowerEdge;
	static CameraManagerC *sInstance;
	CameraManagerC(){};
};