/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Handles the geometry wars grid      **
*************************************************/

#define FIELD_MANAGER_CPP
#include <windows.h>											// Header File For Windows
#include <stdio.h>												// Header File For Standard Input / Output
#include <stdarg.h>												// Header File For Variable Argument Routines
#include <math.h>												// Header File For Math Operations
#include "gl\gl.h"												// Header File For The OpenGL32 Library
#include "gl\glu.h"												// Header File For The GLu32 Library
#include "gl\glut.h"
#include "baseTypes.h"
#include "openglframework.h"	
#include "collinfo.h"
#include "object.h"
#include "field.h"
#include "FieldManager.h"
#include "gamePlayVariables.h"

FieldManagerC* FieldManagerC::sInstance=NULL;

FieldManagerC *FieldManagerC::CreateInstance()
{
	if(sInstance!=NULL)return sInstance;
	else
	sInstance = new FieldManagerC();
	return sInstance;
}

void FieldManagerC::init()
{
	mFieldPtr = new FieldC(0.0f,0.0f, 2200, 2600,0xFFFFFFFF);
	currentTime = 0;
	timeBetweenUpdates = GRID_TIME_BETWEEN_UPDATES;
}

FieldC *FieldManagerC::getFieldPtr()
{
	return mFieldPtr;
}

void FieldManagerC::renderField()
{
	mFieldPtr->render();
}

void FieldManagerC::shutdown()
{
	delete mFieldPtr;
}

void FieldManagerC::applyPush(Vector3C* position, float_t radius, float_t amount, Vector3C* color)
{
	mFieldPtr->applyPush(position, radius, amount, color);
}

void FieldManagerC::applyGravityPull(Vector3C* position, float_t radius, float_t amount, Vector3C* color)
{
	mFieldPtr->applyGravityPull(position, radius, amount, color);
}

void FieldManagerC::updateField(DWORD milliseconds)
{
	currentTime += milliseconds;
	//printf("current time %lf\n", currentTime);
	if(currentTime >= timeBetweenUpdates)
	{
		currentTime = 0;
		mFieldPtr->update(milliseconds);
	}
}
void FieldManagerC::resetGrid()
{
	mFieldPtr->resetGrid();
}

//Color
void FieldManagerC::applyColor(Vector3C* position, float_t radius, Vector3C* color)
{
	mFieldPtr->applyColor(position, radius, color);
}