/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Handles the geometry wars grid      **
*************************************************/

#ifndef FIELDMANAGER_H
#define FIELDMANAGER_H

#include "field.h"

class FieldManagerC
{
public:
	static FieldManagerC	*CreateInstance();
	static FieldManagerC	*GetInstance() {return sInstance;};
	~FieldManagerC(){};
	FieldC* getFieldPtr();
	void init();
	void renderField();
	void shutdown();
	void updateField(DWORD milliseconds);
	void applyPush(Vector3C* position, float_t radius, float_t amount, Vector3C* color);
	void applyGravityPull(Vector3C* position, float_t radius, float_t amount, Vector3C* color);
	void resetGrid();

	//Color
	void applyColor(Vector3C* position, float_t radius, Vector3C* color);
private:
	static FieldManagerC *sInstance;
	FieldManagerC(){};
	FieldC *mFieldPtr;

	//Update loop timer variables.
	double64_t currentTime;
	double64_t timeBetweenUpdates;
};
#endif