/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Enemy class with modifed render and **
**update to branch from standard enemy behavior.**
*************************************************/

#ifndef GATEENEMY_H
#define GATEENEMY_H

#include "enemy.h"
#include "Vector2.h"

/*************************************************
**Summary: Enemy which explodes if you hit the 	**
**middle else you die on impact.				**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class GateEnemyC : public EnemyC
{
public:
	//Function prototypes.
	virtual void update(double64_t milliseconds);
	virtual void init(float_t initPosX, float_t initPosY, float_t initVelX, float_t initVelY, int32_t id);
	virtual void render();
	//bool checkIfCollide(int32_t playerNumber);
	//Overrided functions
	virtual bool checkIfBulletsCollide(int32_t playerNumber);
	virtual bool checkIfPlayerPositionCollide(double64_t radius, int32_t playerNumber);

private:
	//Edges Positions
	Vector3C pointAPosition;
	Vector3C pointBPosition;
	//Edges Velocities
	Vector3C pointAVelocity;
	Vector3C pointBVelocity;
	//Half distance of the line
	float_t lineRadius;
};
#endif