/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: A point on the grid.                 **
*************************************************/

#ifndef GRIDPOINT_H
#define GRIDPOINT_H

#include "baseTypes.h"
#include "Vector2.h"
#include "Vector3.h"
#include "gamePlayVariables.h"

typedef unsigned long       DWORD;
#define  RETURN_PUSH_AMOUNT	0.005f


class GridPointC
{
public:
    GridPointC();
	void setPosition(Vector3C newPosition);
	void applyForce(Vector3C newForce);

	void clearVelocity();

	void update(DWORD milliseconds);

	Vector3C getCurrentPosition();
	Vector3C getCurrentVelocity();
	Vector3C getInitalPosition();

	void setLocked(bool newLocked);

	//Color
	void setCurrentColor(Vector3C* newCurrentColor);
	void setColorChange(Vector3C* newColorChange);
	void setColor(Vector3C* newColor);
	void mergeColorChange(Vector3C* newColor);
	void appyPushColorChange(Vector3C* newColor);
	Vector3C* getCurrentColor();
	Vector3C* getColorChange();

	void decreaseColor(float_t scaleAmount);

	void updateColor();

	Vector3C* getVelocity();
	void setNumberOfColorSums(float_t newSum);
	float_t returnNumberOfColorSums();
private:
	void CollideField(void);

	//The velocity is sum of all forces acting on the point
	Vector3C currentPosition;
	Vector3C velocity;

	Vector3C initalPosition;

	bool locked;

	Vector3C currentColor;
	Vector3C colorChange;
	float_t numberOfColorSumValues;
};

#endif
