/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: The input manager. Handles keyboard  **
**			and mouse input.					**
*************************************************/

#ifndef INPUT_MANAGER_H
#define INPUT_MANAGER_H

#include "baseTypes.h"
#include "Vector2.h"
#include "Sprite.h"

class InputManagerC
{
public:
	static InputManagerC	*CreateInstance();
	static InputManagerC	*GetInstance() {return sInstance;};
	void init();
	void update();

	Coord2D* getCurrentMousePosition(){};
	
	//Keyboard interface.
	void setKeys(int32_t newKeys[256]);
	void resetKeys();

	int32_t currentKeys[256];
	int32_t previousKeys[256];

	//Mouse.
	void setMouse(bool8_t newLClick, bool8_t newRClick, int32_t newMouseX, int32_t newMouseY);

	bool8_t isLeftMouseButtonDown();
	Vector2C returnMouseScreenPosition();
	Vector2C returnMouseGamePosition();
	void draw();
	void setScreenInformation(float_t newWindowWidth, float_t newWindowHeight, float_t newGameWorldWidth, float_t newGameWorldHeight);
private:
	InputManagerC(){};
	static InputManagerC *sInstance;
	
	bool8_t mouseLClick;
	bool8_t mouseRClick;

	int32_t mouseX;
	int32_t mouseY;

	SpriteC mouseSprite;
	//Screen Settings
	float_t windowWidth;
	float_t windowHeight;

	float_t gameWorldWidth;
	float_t gameWorldHeight;
};
#endif