/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Menu item which is displayed by the  **
**menu manager.									**
*************************************************/

#include <windows.h>									
#include <stdio.h>											
#include <stdarg.h>									
#include <math.h>											
#include "gl\gl.h"										
#include "gl\glu.h"											
#include "gl\glut.h"
#include "baseTypes.h"
#include "MenuItem.h"

MenuItemC::MenuItemC()
{
}

MenuItemC::~MenuItemC()
{
}

void MenuItemC::init(char8_t* initName, Vector3C initPosition, float_t red, float_t green, float_t blue, bool initActive)
{
	//Init the menu item.
	position.x = initPosition.x;
	position.y = initPosition.y;
	name = initName;
	defaultColor.x = red;
	defaultColor.y = green;
	defaultColor.z = blue;
	color.x = red;
	color.y = green;
	color.z = blue;
	active = initActive;
}

void MenuItemC::update(double64_t milliseconds)
{
	if(active == true)
	{
		color.x = 1.0f;
		color.y = 1.0f;
		color.z = 1.0f;
	}
	else
	{
		color.x = defaultColor.x;
		color.y = defaultColor.y;
		color.z = defaultColor.z;
	}
}

void MenuItemC::setActive(bool updateActive)
{
	active = updateActive;
}

bool MenuItemC::getActive()
{
	return active;
}

void MenuItemC::render()
{
	glPushMatrix();
	glScalef(1.5f, 1.5f, 1.0f);
	//Set the font color, select font and draw text out.
	GUIManagerC::GetInstance()->setFontColor(color.x,color.y,color.z);
	GUIManagerC::GetInstance()->startDefaultFont(position.x,position.y);
	GUIManagerC::GetInstance()->glFontTextOut(name,50,50,0);
	GUIManagerC::GetInstance()->endDefaultFont();
	glPopMatrix();
}