/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Menu item which is displayed by the  **
**menu manager.									**
*************************************************/

#ifndef MENUITEM_H
#define MENUITEM_H

#include "Vector2.h"
#include "Vector3.h"
#include "baseTypes.h"
#include "GUIManager.h"

/*************************************************
**Summary: Menu item class which stores object  **
**info about what to draw on the screen.		**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class MenuItemC
{
public:
	MenuItemC();
	~MenuItemC();
	//Function prototypes.
	void init(char* initName, Vector3C initPosition, float red, float green, float blue, bool initActive);
	void render();
	void update(double milliseconds);
	bool getActive();
	void setActive(bool updateActive);
private:
	Vector3C defaultColor;
	Vector3C color;
	Vector3C position;
	char *name;
	bool active;
};
#endif