#ifndef OBJECT_H
#define OBJECT_H

#include "Vector2.h"
#include "Vector3.h"
#include "collInfo.h"

class EnemyC;
class FieldC;
class PlayerC;
class BulletC;
class PickUpC;
class BombC;

class ObjectC
{
    friend class EnemyC;
	friend class FieldC;
	friend class PlayerC;
	friend class BulletC;
	friend class PickUpC;
	friend class BombC;

public:
    ObjectC(float initPosX, float initPosY, float initVelX, float initVelY);
    ObjectC();
    ~ObjectC();
    void setPosition(Vector3C *posToSet) {mPosition.x = posToSet->x;mPosition.y = posToSet->y;};
    Vector3C *getPosition() {return &mPosition;};
    void setVelocity(Vector3C *velToSet) {mVelocity.x = velToSet->x;mVelocity.y = velToSet->y;};
    void setVelocity(float x, float y) {mVelocity.x = x;mVelocity.y = y;};
    Vector3C *getVelocity() {return &mVelocity;};
    void setCollInfo(CollInfoC *collInfoToSet) {mCollInfo = *collInfoToSet;};
    CollInfoC *getCollInfo() {return &mCollInfo;};
	int32_t getID() {return mID;};
	void setID(int32_t id) {mID = id;};
	virtual void render()=0;

	void disable() {mEnabled = false;};
    void enable() {mEnabled = true;};
	bool getEnabled();
protected:
	bool mEnabled;
    Vector3C mPosition;
    Vector3C mVelocity;
    CollInfoC mCollInfo;
	int32_t mID;

	//Temporary Vector 3 used for almost anything and everything
	Vector3C temp;
};
#endif