/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Basic particle system manager deals **
**with the processing of all particles in game. **
*************************************************/

#ifndef PARTICLECIRCLEEMITTER_H
#define PARTICLECIRCLEEMITTER_H
#include "ParticleEmitter.h"
#include "Particle.h"
#include "baseTypes.h"
#include "Vector3.h"
#include <vector>

using namespace std;

/*************************************************
**Summary: Particle Circle Emitter is a class 	**
**which handles emitting particles in a circle. **
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class ParticleCircleEmitterC : public ParticleEmitterC
{
public:
	ParticleCircleEmitterC();
	~ParticleCircleEmitterC();
	//Function prototypes.
	void init(double initTimeBetweenUpdates, double initTotalTimeToEmit, Vector3C initPosition, Vector3C initVelocity, Vector3C initAngularVelocity, int32_t minParticles, int32_t maxParticles);
	void update(double milliseconds);
	void renderParticles();
private:
};
#endif