/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Basic particle system manager deals **
**with the processing of all particles in game. **
*************************************************/

#ifndef PARTICLEPOINTEMITTER_H
#define PARTICLEPOINTEMITTER_H
#include "ParticleEmitter.h"
#include "Particle.h"
#include "baseTypes.h"
#include "Vector3.h"
#include <vector>

using namespace std;

/*************************************************
**Summary: Particle Point emitter is a class	**
**which handles emitting particles at a point.	**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class ParticlePointEmitterC : public ParticleEmitterC
{
public:
	ParticlePointEmitterC();
	~ParticlePointEmitterC();
	//Function prototypes.
	void init(double64_t initTimeBetweenUpdates, double64_t initTotalTimeToEmit, Vector3C initPosition, Vector3C initVelocity, Vector3C initAngularVelocity, int32_t minParticles, int32_t maxParticles);
	void update(double64_t milliseconds);
	void renderParticles();

private:
};
#endif