/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Pick up manager handles processing	**
**objects that can be picked up by players.		**
*************************************************/

#ifndef PickUp_H
#define PickUp_H

#include "Sprite.h"
#include "ParticleManager.h"
#include "Object.h"
#include "baseTypes.h"

/*************************************************
**Summary: Pick up object which detects and     **
**projects pick upobjects toward nearby player. **
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class PickUpC : public ObjectC
{
public:
    PickUpC();
	PickUpC(float_t initPosX, float_t initPosY, float_t initVelX, float_t initVelY,int32_t id);
    ~PickUpC();
	//Function prototypes.
	void setPickUpColor(long color) {mPickUpColor = color;};
    long getPickUpColor() {return mPickUpColor;};
    void update(double64_t milliseconds);
    virtual void render();
	void DoCollisions();
    void setRadius(float_t radius) {mCollInfo.param1 = radius;mRadius = radius;};
	void setRandomColor();
	void reduceVelocity(float_t factor);
	bool getEnabled();
	//Life Time.
	int32_t returnLifetime();
	//Move Towards Player.
	void setMoveTowarsPlayer(int32_t newMoveTowardsPlayer);
	int32_t returnMoveTowardsPlayer();
private:
	int32_t lifetime;
	int32_t moveTowardsPlayer;
	void CollideField();
	long mPickUpColor;
    float mRadius;
	bool mAtRest;
	SpriteC mySprite;
};
#endif