/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary:  Pick up manager handles processing	**
**objects that can be picked up by players.		**
*************************************************/

#ifndef PICKUPMANAGER_H
#define PICKUPMANAGER_H

#include "baseTypes.h"
#include "PickUp.h"

/*************************************************
**Summary: Pick up manager class which handles	**
**processing all objects that can be picked up. **
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class PickUpManagerC
{
public:
	static PickUpManagerC	*CreateInstance();
	static PickUpManagerC	*GetInstance() {return sInstance;};
	~PickUpManagerC(){};

	//Function prototypes.
	int32_t	getNumPickUps() {return NUM_PICKUPS;};
	void init();
	void shutdown();
	void updatePickUps(double64_t milliseconds);
	PickUpC* getPickUpPtr(int32_t index);
	void	renderPickUps();
	Vector3C getPickUpPosition(int32_t index);
	void reset();
	void createNewPickup(Vector3C newPosition, Vector3C newVelocity);
private:
	vector<PickUpC*> pickUpList;
	vector<PickUpC*>::iterator pickUpIterator;
	static PickUpManagerC *sInstance;
	static const int32_t NUM_PICKUPS = 1;
	PickUpManagerC(){};
};
#endif