/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Player manager which handles all		**
**players movements and information.			**
*************************************************/

#ifndef PLAYERMANAGER_H
#define PLAYERMANAGER_H

#include "baseTypes.h"
#include "player.h"

/*************************************************
**Summary: Player manager to handle all players. **
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class PlayerManagerC
{
public:
	static PlayerManagerC *CreateInstance();
	static PlayerManagerC *GetInstance() {return sInstance;};
	~PlayerManagerC(){};
	//Function prototypes.
	int32_t	getNumPlayers() {return NUM_PLAYERS;};
	void init();
	void shutdown();
	void updatePlayers(unsigned long milliseconds);
	PlayerC* getPlayerPtr(int32_t index);
	void	renderPlayers();
	Vector3C getPlayerPosition(int32_t index);
private:
	PlayerC **playerPtrs;
	static PlayerManagerC *sInstance;
	static const int32_t NUM_PLAYERS = 1;
	PlayerManagerC(){};

	
	//Temporary Vector 3 used for almost anything and everything
	Vector3C temp;
};
#endif