/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: A sprite class. Used to draw basic   **
**		   sprites.	            				**
*************************************************/

#define STATE_MANAGER_CPP
#include <windows.h>										
#include <stdio.h>												
#include <stdarg.h>											
#include <math.h>											
#include "gl\gl.h"												
#include "gl\glu.h"											
#include "gl\glut.h"
#include <assert.h>
#include "baseTypes.h"
#include "openglframework.h"	
#include "SpriteManager.h"
#include "random.h"
#include "stateManager.h"
#include "soil.h"
#include "Vector2.h"
#include "Vector3.h"
#include "Sprite.h"

SpriteC::SpriteC()
{
}

SpriteC::SpriteC(int newID, float newX, float newY, float newZ, float newWidth, float newHeight, float newRotation, float newTextureX, float newTextureY, float newTextureWidth, float newTextureHeight)
{
	textureID = newID;
	position.x = newX;
	position.y = newY;
	position.z = newZ;
	width = newWidth;
	height = newHeight;
	rotation = newRotation;
	texturePosition.x = newTextureX;
	texturePosition.y = newTextureY;
	textureWidth = newTextureWidth;
	textureHeight = newTextureHeight;

	centerBased = false;
}

//Sets
void SpriteC::setUp(int newID, float newX, float newY, float newZ, float newWidth, float newHeight, float newRotation, float newTextureX, float newTextureY, float newTextureWidth, float newTextureHeight)
{
	textureID = newID;
	position.x = newX;
	position.y = newY;
	position.z = newZ;
	width = newWidth;
	height = newHeight;
	rotation = newRotation;
	texturePosition.x = newTextureX;
	texturePosition.y = newTextureY;
	textureWidth = newTextureWidth;
	textureHeight = newTextureHeight;

	centerBased = false;
}

void SpriteC::setTextureID(int newID)
{
	textureID = newID;
}

void SpriteC::setPosition(float newX, float newY, float newZ)
{
	position.x = newX;
	position.y = newY;
	position.z = newZ;
}

void SpriteC::setScale(float newWidth, float newHeight)
{
	width = newWidth;
	height = newHeight;
}

void SpriteC::setRotation(float newRotation)
{
	rotation = newRotation;
}

//Texture
void SpriteC::setTexturePosition(float newTextureX, float newTextureY)
{
	texturePosition.x = newTextureX;
	texturePosition.y = newTextureY;
}
void SpriteC::setTextureScale(float newTextureWidth, float newTextureHeight)
{
	textureWidth = newTextureWidth;
	textureHeight = newTextureHeight;
}

void SpriteC::setCentered(bool newCentered)
{
	centerBased = newCentered;	
}

//Returns
bool SpriteC::returnedCentered()
{
	return(centerBased);
}

//Quad
Vector3C SpriteC::returnPosition()
{
	return(position);
}

float SpriteC::returnWidth()
{
	return(width);
}

float SpriteC::returnHeight()
{
	return(height);
}

float SpriteC::returnRotation()
{
	return(rotation);
}

int SpriteC::returnTextureID()
{
	return(textureID);
}

//Texture
Vector2C SpriteC::returnTexturePosition()
{
	return(texturePosition);
}

float SpriteC::returnTextureWidth()
{
	return(textureWidth);
}

float SpriteC::returnTextureHeight()
{
	return(textureHeight);
}