/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: A sprite class. Used to draw basic   **
**		   sprites.	            				**
*************************************************/

#ifndef SPRITE_H
#define SPRITE_H

#include "Vector3.h"
#include "Vector2.h"

class SpriteC
{
public:
	SpriteC();
	SpriteC(int newID, float newX, float newY, float newZ, float newWidth, float newHeight, float newRotation, float newTextureX, float newTextureY, float newTextureWidth, float newTextureHeight);

	//Sets
	void setUp(int newID, float newX, float newY, float newZ, float newWidth, float newHeight, float newRotation, float newTextureX, float newTextureY, float newTextureWidth, float newTextureHeight);
	void setTextureID(int newID);
	void setPosition(float newX, float newY, float newZ);
	void setScale(float newWidth, float newHeight);
	void setRotation(float newRotation);
	void setCentered(bool newCentered);
	//Texture
	void setTexturePosition(float newTextureX, float newTextureY);
	void setTextureScale(float newTextureWidth, float newTextureHeight);

	//Returns
	int returnTextureID();
	bool returnedCentered();

	//Quad
	Vector3C returnPosition();
	float returnWidth();
	float returnHeight();
	float returnRotation();

	//Texture
	Vector2C returnTexturePosition();
	float returnTextureWidth();
	float returnTextureHeight();

private:
	bool centerBased;
	int textureID;

	//Position
	Vector3C position;
	Vector2C texturePosition;

	//Scale
	int width;
	int height;
	int textureWidth;
	int textureHeight;

	//Rotation
	float rotation;
};
#endif