/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: A sprite manager. Holds and draws    **
**		   the actual sprites.    				**
*************************************************/

#ifndef SPRITEMANAGER_H
#define SPRITEMANAGER_H

#include "Sprite.h"
#include "Texture.h"
#include "baseTypes.h"

#define MOOD_UPDATE_DELTA_TIME 100

struct VertexFormatPos3Tex2
{   // Custom vertex format for position+normal
	float tu , tv ;             ///< texture coordinates	
	float px , py , pz ;        ///< untransformed (world-space) position
};

class SpriteManagerC
{
public:
	static SpriteManagerC	*CreateInstance();
	static SpriteManagerC	*GetInstance() {return sInstance;};
	~SpriteManagerC(){};

	void		init(int width, int height);
	void		shutdown();
	//Drawing Sprite
	void		drawSprite(SpriteC mySprite);
	//Drawing particle
	void drawParticle(SpriteC mySprite, float_t red, float_t blue, float_t green, float_t alpha);

private:
	static SpriteManagerC *sInstance;
	SpriteManagerC(){};
	
	double64_t mLastUpdateTime;
	double64_t mCurrentTime;
	TextureC* textureList;
	SpriteC* spriteArray;

	int32_t currentTextureNumber;
};

#endif