/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Helper Vector2 class.				**
*************************************************/

#include <windows.h>											
#include "baseTypes.h"
#include "Vector2.h"
#include <math.h>												
#include "gamePlayVariables.h"

Vector2C::Vector2C()
{
	x = 0.0f;
	y = 0.0f;
}

Vector2C::Vector2C(float_t newX, float_t newY)
{
	x = newX;
	y = newY;
}

void Vector2C::addVector(Vector2C a)
{
	x += a.x;
	y += a.y;
}

void Vector2C::subtractVector(Vector2C a)
{
	x -= a.x;
	y -= a.y;
}

void Vector2C::normalize()
{
	float length = sqrt(powf(x, UNIT_CIRCLE_MODIFER) + powf(y, UNIT_CIRCLE_MODIFER));
	x /= length;
	y /= length;
}

float_t Vector2C::getLength()
{
	return(sqrt(powf(x, UNIT_CIRCLE_MODIFER) + powf(y, UNIT_CIRCLE_MODIFER)));
}

void Vector2C::scaleVector(float_t scaleAmount)
{
	x *= scaleAmount;
	y *= scaleAmount;
}

float_t Vector2C::dotProduct(Vector2C a)
{
	return((x * a.x) + (y * a.y));
}

float_t Vector2C::angleBetween(Vector2C a)
{
	return(acos(dotProduct(a)));
}

void Vector2C::setValues(float_t newX, float_t newY)
{
	x = newX;
	y = newY;
}

float_t Vector2C::distance(Vector2C b)
{
	float_t returnValue = 0;

	returnValue = sqrtf(powf((b.x - this->x), HALF) + powf((b.y - this->y), HALF));
	return(returnValue);
}

void Vector2C::addXComponet(float_t xAmount)
{
	x += xAmount;
}
void Vector2C::addYComponet(float_t yAmount)
{
	y += yAmount;
}

void Vector2C::rotate(float_t angle)
{
	x = (x * cosf(angle)) + (-y * sinf(angle));
	y = (x * sinf(angle)) + (y * cosf(angle));
}

void Vector2C::addVectorWithScale(Vector2C a, float_t scale)
{
	x += (a.x * scale);
	y += (a.y * scale);
}