/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Helper Vector2 class.				**
*************************************************/

#ifndef VECTOR2_H
#define VECTOR2_H

#include "baseTypes.h"

/*************************************************
**Summary: Vector 2 object.						**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class Vector2C
{
public:
    Vector2C();
	Vector2C(float_t newX, float_t newY);
	//Function prototypes.
	void setValues(float_t newX, float_t newY);
	void addVector(Vector2C a);
	void subtractVector(Vector2C a);
	void normalize();
	float_t getLength();
	void scaleVector(float_t scaleAmount);
	float_t dotProduct(Vector2C a);
	float_t angleBetween(Vector2C a);
	float_t distance(Vector2C b);
	float_t x;
	float_t y;
	void addXComponet(float_t xAmount);
	void addYComponet(float_t yAmount);
	void rotate(float_t angle);
	void addVectorWithScale(Vector2C a, float_t scale);
private:
};
#endif