/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: Helper Vector3 class.				**
*************************************************/

#ifndef VECTOR3_H
#define VECTOR3_H

#include "baseTypes.h"
#include "Vector2.h"

/*************************************************
**Summary: Vector 2 object.						**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class Vector3C
{
public:
    Vector3C();
	Vector3C(float_t newX, float_t newY, float_t newZ);
	Vector3C(float_t newX, float_t newY);
	//Function prototypes.
	void addVector(Vector3C a);
	void subtractVector(Vector3C a);

	void add2DQuickVector(Vector3C a);
	void subtract2DQuickVector(Vector3C a);


	void normalize();
	float_t getLength();

	void scaleVector(float_t scaleAmount);
	float_t angleBetween(Vector3C a);

	void setEqualToVector(Vector3C a);
	Vector3C crossProduct(Vector3C a, Vector3C b);
	float_t dotProduct(Vector2C b);
	float_t dotProduct(Vector3C b);
	float_t distance(Vector3C b);

	void addXComponet(float_t xAmount);
	void addYComponet(float_t yAmount);
	void addZComponet(float_t yAmount);

	void rotateAroundZAxis(float_t angle);
	void addVectorWithScale(Vector3C a, float_t scale);

	void setValues(float_t newX, float_t newY);
	void setValues(float_t newX, float_t newY, float_t newZ);

	float_t x;
	float_t y;
	float_t z;
private:
};
#endif