/*************************************************
**Authors: Alex Lemke, Kevin Cartrette			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: The actual geometry wars grid        **
*************************************************/

#ifndef FIELD_H
#define FIELD_H

#include "Sprite.h"
#include "GridPoint.h"
#include "Object.h"

class FieldC : public ObjectC
{
public:
	FieldC(float_t x, float_t y, uint32_t height, uint32_t width, uint32_t initColor);
    ~FieldC();
    void setColor(uint32_t color) {mFieldColor = color;};
    long getColor() {return mFieldColor;};
    void update(DWORD milliseconds);
    virtual void render();
    void setWidth(uint32_t width) {mWidth = width;};
    uint32_t getWidth() {return mWidth;};
    void setHeight(uint32_t height) {mHeight = height;};
    uint32_t getHeight() {return mHeight;};

	void moveUp();

	void applyPush(Vector3C* position, float_t radius, float_t amount, Vector3C* color);
	void applyGravityPull(Vector3C* position, float_t radius, float_t amount, Vector3C* color);
	void gridUpdate(DWORD milliseconds);

	void resetGrid();

	void applyColor(Vector3C* position, float_t radius, Vector3C* color);

private:
	void renderGrid();
	void renderEdges();

    uint32_t mFieldColor;
	uint32_t mHeight;
	uint32_t mWidth;
	bool8_t mEnabled;

	SpriteC mySprite;

	//Grid
	int numberOfGridPoints;
	GridPointC ***gridPoints;
};
#endif