#ifndef GAMEPLAYVARIABLES_H
#define GAMEPLAYVARIABLES_H




//Debug flags.
#define DEBUG 0
#define DRAW_COLLISIONS 0

//Math variables.
#define PI_DEFINE 3.14159265358979323846f
#define UNIT_CIRCLE_MODIFER 2.0f
#define TWO 2.0f
#define HALF 2.0f
#define DOUBLE 2.0f
#define HALF_DEGREES_OF_CIRCLE 180.0f
#define ONE_FORTH_OF_CIRCLE 90.0f
#define DEGREES_OF_CIRCLE 360
#define DEGREES_TO_RADIANS (PI_DEFINE/HALF_DEGREES_OF_CIRCLE)

//Enemy manager time variables.
#define ENEMY_TIME_BETWEEN_UPDATES 30
#define ENEMY_TIME_BETWEEN_SPAWNS 5000

//Enemy variables inside enemy manager.
#define MIN_ENEMIES 30
#define MAX_ENEMIES 80
#define DART_ENEMY_OFFSET 70
#define NUMBER_PROTONS_ON_BLACK_HOLE_DEATH 4

//Circle emitter variables for enemies.
#define CIRCLE_EMITTER_VELOCITY 0.003f
#define CIRCLE_EMITTER_ANGULAR_VELOCITY 0
#define CIRCLE_EMITTER_TIME_UPDATE 30
#define CIRCLE_EMITTER_TIME_TO_LIVE 1//200
#define CIRCLE_EMITTER_MIN_PARTICLES 300
#define CIRCLE_EMITTER_MAX_PARTICLES 400

//Circle emitter variables for menu screen.
#define CIRCLE_EMITTER_POSITION_RANDOM_RANGE 500.0f
#define CIRCLE_EMITTER_MENU_TIME_UPDATE 20
#define CIRCLE_EMITTER_MENU_TIME_TO_LIVE 1400
#define CIRCLE_EMITTER_MENU_SIZE 1.1f

//Point emitter variables for ship.
#define SHIP_POINT_EMITTER_TIME_UPDATE 10
#define SHIP_POINT_EMITTER_TIME_TO_LIVE 200
#define SHIP_POINT_EMITTER_SIZE 2
#define SHIP_POINT_EMITTER_MIN_PARTICLES 100
#define SHIP_POINT_EMITTER_MAX_PARTICLES 300

//Max number pick up orbs when enemy dies.
#define MAX_NUMBER_PICKUPS 4

//Grid
#define GRID_TIME_BETWEEN_UPDATES 30
//Grid Color
#define GRID_COLOR_BLEND_AMOUNT 0.5f
#define COLOR_DCREASE_RATE 0.99f
//Grid variables when enemy is killed.
#define GRID_RADIUS_APPLIED_ON_ENEMY_DEATH 100.0f
#define GRID_FORCE_APPLIED_ON_ENEMY_DEATH 0.05f
//Grid variables on menu screen.
#define GRID_RADIUS_APPLIED_ON_MENU 100.0f
#define GRID_FORCE_APPLIED_ON_MENU 0.05f


//Max range plus and minus value to spawn enemies.
#define ENEMY_RANDOM_SPAWN_RANGE 1000.0f

//Particle manager variables
#define MAX_PARTICLES_TO_RENDER 4000

#define PARTICLE_MANAGER_TIME_BETWEEN_UPDATES 1
#define PARTICLE_MANAGER_TIME_BETWEEN_MENU_UPDATES 1000
//Particle circle emitter variables.
#define PARTICLE_CIRCLE_EMITTER_TEXTURE_ID 4
#define PARTICLE_CIRCLE_EMITTER_VELOCITY_MAX_MODIFER 1
#define PARTICLE_CIRCLE_EMITTER_MIN_TIME_TO_LIVE 100.0f//300.0f
#define PARTICLE_CIRCLE_EMITTER_MAX_TIME_TO_LIVE 100.0f//500.0f
//Particle point emitter variables.
#define PARTICLE_POINT_EMITTER_TEXTURE_ID 4
#define PARTICLE_POINT_EMITTER_MIN_TIME_TO_LIVE 100.0f
#define PARTICLE_POINT_EMITTER_MAX_TIME_TO_LIVE 100.0f
#define PARTICLE_POINT_EMITTER_VELOCITY_MAX_MODIFER 1
//Particle variables.
#define PARTICLE_USE_TEXTURES 0
#define PARTICLE_FRICTION 0.99f
#define PARTICLE_BOUNCE_OFF_WALL 0
#define PARTICLE_LENGTH_MODIFIER 10.0f
#define PARTICLE_RANDOM_COLOR_MIN_RED 0.5f
#define PARTICLE_RANDOM_COLOR_MAX_RED 1.0f
#define PARTICLE_RANDOM_COLOR_MIN_BLUE 0.5f
#define PARTICLE_RANDOM_COLOR_MAX_BLUE 1.0f
#define PARTICLE_RANDOM_COLOR_MIN_GREEN 0.5f
#define PARTICLE_RANDOM_COLOR_MAX_GREEN 1.0f
#define PARTICLE_RANDOM_VELOCITY_MIN_MODIFER 1.0f
#define PARTICLE_RANDOM_VELOCITY_MAX_MODIFER 1.0f
//Sound manager variables.
#define MAX_NUMBER_SOUNDS 32
//Camera manager variables.
#define CAMERA_VIEW_SIZE_X 2000
#define CAMERA_VIEW_SIZE_Y 2000
//Menu manager variables.
#define MENU_START_X -1150.0f
#define MENU_START_Y -1100.0f
#define MENU_ITEM_OFFSET -100.0f
#define MENU_TIME_BETWEEN_UPDATES 120
#define BLACK_HOLE_MODE_EXTRA_ENEMIES 15
#define DART_MODE_EXTRA_ENEMIES 10
#define GATE_MODE_GATES_PER_SPAWN 5
//Enemy variables.
#define ENEMY_RADIUS 16.0f;
#define ENEMY_TEXTURES 1
#define ENEMY_MAX_SPEED 1.5f
//Gate enemy variables.
#define GATE_LENGTH 90.0f
//Spinner enemy variables.
#define SPIN_RATE_EACH_FRAME 3.0f

//Player variables
#define GOD_MODE 0
#define NUMBER_BOMBS 3
#define INVINCIBLE_DELAYTIME 5000.0f
#define BOMB_DELAYTIME 150.0f   //In milliseconds
#define NUMBER_START_LIVES 3
#define MODIFER_FOR_SHEILD_RADIUS 3.5f
#define SHIP_RADIUS 14
#define MAX_VELOCITY 5.0f
#define PLAYER_FRICTION 0.7f

//Bullet variables.
#define BULLET_SCALE_FACTOR 2.0f
#define BULLET_RATE_ROTATION 0.075f
//Black Hole variables.
#define BLACK_HOLE_STRENGTH 1.0f
//Dart enemy variables.
#define DART_VELOCITY_MODIFER 0.9f
//Enemy Scores
#define BLACK_HOLE_SCORE 100
#define CHASER_SCORE 60
#define DART_SCORE 30
#define DODGER_SCORE 80
#define GATE_SCORE 40
#define PROTON_SCORE 50
#define SPINNER_SCORE 30

//Field variables
#define NUMBER_OF_GRIDPOINTS 40 //60
#define DRAW_ONLY_EFFECTED 1
#define DRAW_EFFECTED_THRESHOLD 0.05f//0.04f

//Memory Leaks
/**#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#ifdef _DEBUG
#define DEBUG_NEW new(_NORMAL_BLOCK, __FILE__, __LINE__)
#define new DEBUG_NEW
#endif*/

#endif