/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: State manager which controls game	**
**state.										**
*************************************************/

#define STATE_MANAGER_CPP
#include <windows.h>											
#include <stdio.h>											
#include <stdarg.h>												
#include <math.h>												
#include "gl\gl.h"												
#include "gl\glu.h"												
#include "gl\glut.h"
#include "baseTypes.h"
#include "openglframework.h"	
#include "stateManager.h"

StateManagerC* StateManagerC::sInstance=NULL;

StateManagerC *StateManagerC::CreateInstance()
{
	if(sInstance!=NULL)return sInstance;
	else

	sInstance = new StateManagerC();
	return sInstance;
}

int32_t StateManagerC::getState()
{
	return mCurrentState;
}

void StateManagerC::setState(int32_t state)
{
	mCurrentState = state;
}

void StateManagerC::shutdown()
{
}

void StateManagerC::togglePause()
{
	if(mCurrentState == GAMEPLAY)
	{
		mCurrentState = GAME_PAUSED;
	}
	else if(mCurrentState == GAME_PAUSED)
	{
		mCurrentState =  GAMEPLAY;
	}
}

void StateManagerC::setGameMode(int32_t gameModeToSet)
{
	gameMode = gameModeToSet;
}

int32_t StateManagerC::getGameMode()
{
	return gameMode;
}

void StateManagerC::setSwitchPauseTimer(int32_t newSwitchPauseTimer)
{
	switchPauseTimer = newSwitchPauseTimer;
}

int32_t	StateManagerC::returnSwitchPauseTimer()
{
	return(switchPauseTimer);
}