/*************************************************
**Authors: Kevin Cartrette, Alex Lemke			**
**Co-Author: Tom Carbone						**
**Date:	11/30/2011								**
**Version:	1.0									**
**Summary: State manager which controls game	**
**state and mode.								**
*************************************************/

#ifndef STATEMANAGER_H
#define STATEMANAGER_H

/*************************************************
**Summary: Keeps track of game state and mode.	**
**Authors: Kevin Cartrette, Alex Lemke			**
*************************************************/
class StateManagerC
{

#include "baseTypes.h"

public:
	static StateManagerC	*CreateInstance();
	static StateManagerC	*GetInstance() {return sInstance;};
	~StateManagerC(){};
	//Enum for valid game states.
	enum 
	{
		INVALID_STATE,
		GAMEPLAY,
		GAME_PAUSED,
		MAIN_MENU,
		SCORE_MENU,
		MAX_STATE
	};
	//Enum for valid game modes.
	enum GAMEMODE
	{
		INVALID_GAMEMODE,
		SURVIVAL_MODE,
		WAVE_MODE,
		WORM_HOLE_MODE,
		PACIFISM_MODE,

		MAX_GAMEMODE
	};
	//Function prototypes.
	int32_t	getState();
	void setState(int32_t stateToSet);
	void shutdown();
	int32_t	getGameMode();
	void setGameMode(int32_t gameModeToSet);
	void togglePause();
	void setSwitchPauseTimer(int32_t newSwitchPauseTimer);
	int32_t	returnSwitchPauseTimer();
private:
	static StateManagerC *sInstance;
	StateManagerC(){};
	int32_t	mCurrentState;
	int32_t	switchPauseTimer;
	int32_t gameMode;
};
#endif